package frames;

import drawing_objects.DrawingShip;
import drawing_objects.IDrawBlocks;
import entities.EntityShip;
import generics.HardGeneric;

import javax.swing.*;
import java.awt.*;

public class HardFrame extends JFrame {
    HardGeneric<EntityShip, IDrawBlocks> generic;
    DrawingShip drawing;
    private final JComponent pictureBox;
    private final int pictureBoxWidth = 200;
    private final int pictureBoxHeight = 100;
    public HardFrame(){
        setLocationRelativeTo(null);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        pictureBox = new JComponent(){
            public void paintComponent(Graphics graphics){
                super.paintComponent(graphics);
                Graphics2D graphics2D = (Graphics2D) graphics;
                if (drawing != null) drawing.drawTransport(graphics2D);
                super.repaint();
            }
        };
        pictureBox.setPreferredSize(new Dimension(pictureBoxWidth, pictureBoxHeight));
        JButton buttonMakeObject = new JButton("Создать новый объект");
        generic = new HardGeneric<>(10, 25, pictureBoxWidth, pictureBoxHeight);
        boolean check;
        do{
            check = generic.insertShip(generic.makeRandomShip());
        }while(check);
        do {
            check = generic.insertBlock(generic.makeRandomBlock());
        }while(check);
        buttonMakeObject.addActionListener(e -> {
                    DrawingShip drawingShip = generic.makeObject();
                    drawingShip.setPosition(pictureBoxWidth / 2 - drawingShip.getWidth()/2, pictureBoxHeight / 2 - drawingShip.getHeight()/2);
                    drawing = drawingShip;
                    draw();
                });
        setLayout(new BorderLayout());
        add(pictureBox, BorderLayout.CENTER);
        add(buttonMakeObject, BorderLayout.SOUTH);
        pack();
        setVisible(true);
    }
    void draw(){pictureBox.repaint();}
}