package generics;

import drawing_objects.DrawingShip;
import movement_strategy.DrawingObjectShip;

import java.util.ArrayList;
import java.util.HashMap;

public class ShipsGenericStorage {
    private final int pictureWidth;
    private final int pictureHeight;
    final HashMap<String, ShipsGenericCollection<DrawingShip, DrawingObjectShip>> shipsStorages;
    public ShipsGenericStorage(int pictureWidth, int pictureHeight){
        shipsStorages = new HashMap<>();
        this.pictureWidth = pictureWidth;
        this.pictureHeight = pictureHeight;
    }
    public ArrayList<String> getKeys(){
        return new ArrayList<>(shipsStorages.keySet());
    }
    public void addSet(String name){
        if(shipsStorages.containsKey(name))
            return;
        shipsStorages.put(name, new ShipsGenericCollection<>(pictureWidth, pictureHeight));
    }
    public void delSet(String name){
        if(!shipsStorages.containsKey(name))
            return;
        shipsStorages.remove(name);
    }
    public ShipsGenericCollection<DrawingShip, DrawingObjectShip> getSet(String name){
        if(!shipsStorages.containsKey(name))
            return null;
        return shipsStorages.get(name);
    }
    public DrawingShip getShip(String collectionName, int position){
        return shipsStorages.get(collectionName).get(position);
    }
}
